const type = getUrlArgumentValue("type");
const tqm = getUrlArgumentValue("tqm");
const nsrsbh = getUrlArgumentValue("nsrsbh");
const appid = getUrlArgumentValue("appid");

window.localStorage.setItem('appid', appid);
window.localStorage.setItem('type', type);
getEWmGzhConfig();

$(function () {
  const subscribe = window.localStorage.getItem('subscribe');
  const forceSubcribe = window.localStorage.getItem('forceSubcribe');
  if (subscribe === "0") { //未关注
    if (forceSubcribe === "1") {
      toPage("/html/wxscaninvoice/Followorder.html");
    } else {
      getOrderInfoByTqm()
    }
  } else {
    getOrderInfoByTqm()
  }

})
//获取二维码图片及logo
function getEWmGzhConfig() {
  let routerType = window.localStorage.getItem('forceSubcribe');
  $.ajax({
    url: config.projectUrl + '/scanInvoice/getEWmGzhConfig',
    type: "post",
    contentType: "application/json;charset=utf-8",
    data: JSON.stringify({
      'tqm': tqm,
      'type': type,
      'nsrsbh': nsrsbh,
    }),
    async: false,
    success: function (data) {
      if (data.code === '0000') {
        if (data.data !== "" && data.data != null && data.data !== undefined) {

          if (data.data.secretKey !== "" && data.data.secretKey != null && data.data.secretKey !== undefined) {
            window.localStorage.setItem('secretKey', data.data.secretKey) //密钥
          }
          console.log(data.data,'data.data.gzhSubcribeEwm')
          if (data.data.gzhSubcribeEwm !== "" && data.data.gzhSubcribeEwm != null && data.data.gzhSubcribeEwm !== undefined) {
            window.localStorage.setItem('ewm', data.data.gzhSubcribeEwm) //二维码图片
          }
          if (data.data.homePageLogo !== "" && data.data.homePageLogo != null && data.data.homePageLogo !== undefined) {
            window.localStorage.setItem('logo', data.data.homePageLogo) //logo图片
          }
          if(data.data.type !=="1"){ //公众号
            //是否强关
            if (data.data.forceSubcribe !== "" && data.data.forceSubcribe != null && data.data.forceSubcribe !== undefined && data.data.forceSubcribe === "1") {
              window.localStorage.setItem('forceSubcribe', data.data.forceSubcribe)
            }
          }
          //赋值
          if(data.data.type){
            routerType = data.data.type;
          }else{
            //如果为空默认不使用公众号
            routerType = "1";
          }


          window.localStorage.setItem('merge', data.data.merge)



        } else {
          window.localStorage.removeItem('ewm')
          window.localStorage.removeItem('logo')
          window.localStorage.removeItem('forceSubcribe')
          window.localStorage.removeItem('routerType')

          //如果为空默认不使用公众号
          routerType = "1";
          window.localStorage.setItem('routerType', routerType) // 1 不使用公众号  !=1 公众号
        }
        if(routerType !=="1"){
          getUserInfoCode(appid);
        }

      } else {
        alert_prompt_open("提示", '获取失败', 1);
      }
    },
    error: function () {
      alert_prompt_open("提示", "当前网络正忙，请稍后重试", 1);
    }
  });
}

function getOrderInfoByTqm() {
  alert_loading_open("数据加载中");
  $.ajax({
    type: "post",
    url: config.projectUrl + '/scanInvoice/getOrderInfoByTqm',
    contentType: "application/json;charset=utf-8",
    data: JSON.stringify({
      "nsrsbh": nsrsbh,
      "tqm": tqm,
      "type": type,
      "openId": localStorage.getItem('openId')
    }),
    async: false,
    success: function (data) {
      alert_loading_close();
      window.sessionStorage.setItem("fpzls", JSON.stringify(data.fpzls)); //发票类型
      window.sessionStorage.setItem("orderInfo", JSON.stringify(data.orderInfo)); // 订单信息
      window.sessionStorage.setItem("orderItemInfoList", JSON.stringify(data.orderItemList)); //开票项目
      window.sessionStorage.setItem("titleInfo", JSON.stringify(data.titleInfo)) //抬头信息
      window.sessionStorage.setItem("ewmInfo", JSON.stringify(data.ewm)) //二维码信息
      if (data.code === "0000") { //处理成功
        getOrderEwm()
        //判断是否是公众号,如果是公众号需要走授权逻辑,如果不是,直接到填开页
        if(window.localStorage.getItem("routerType") === "1"){
          toPage("/html/wxscaninvoice/writing.html");
        }else{
          if (data.orderInfo.authOrderId !== "" && data.orderInfo.authOrderId != null && data.orderInfo.authOrderId !== undefined) {
            const invoiceMes = {
              tqm: data.orderInfo.tqm,
              openId: localStorage.getItem('openId'),
              unionId: localStorage.getItem('unionId'),
              type: type,
              kphjje: data.orderInfo.kphjje,
              appid: appid,
              xhfNsrsbh: nsrsbh
            };
            $.ajax({
              url: config.projectUrl + '/scanInvoice/getAuthUrl',
              type: "post",
              data: JSON.stringify(invoiceMes),
              contentType: "application/json;charset=utf-8",
              async: false,
              success: function (data) {
                if (data.code === '0000') {
                  alert_loading_close();
                  if(window.sessionStorage.getItem('routerType') ==="1"){ //其他
                    toPage("/html/wxscaninvoice/successTip.html");
                  }else{
                    if (data.data.auth_url != null && data.data.auth_url !== undefined && data.data.auth_url !== "") {
                      window.location.replace(data.data.auth_url);
                    } else {
                      toPage("/html/wxscaninvoice/Followorder.html");
                    }
                  }
                } else if(data.code === '1001'){
                  toPage("/html/wxscaninvoice/Followorder.html");
                }else if(data.code === '9998'){
                  alert_prompt_open("提示", data.msg, 1);
                }else{
                  toPage("/html/wxscaninvoice/exception.html?num=2");
                }
              },
              error: function () {
                alert_prompt_open("提示", "当前网络正忙，请稍后重试", 1);
              }
            });
          } else {
            toPage("/html/wxscaninvoice/writing.html");
          }
        }

      } else if (data.code === "1099") { //二维码失效
        toPage("/html/wxscaninvoice/exception.html?num=1");
      } else if (data.code === "9999") { //解密出错
        toPage("/html/wxscaninvoice/exception.html?num=2");
      } else if (data.code === "1098") { //二维码不存在
        toPage("/html/wxscaninvoice/exception.html?num=4");
      } else if (data.code === "3002") {
        alert_prompt_open("提示", data.message, 1);
      }
    },
    error: function (data) {
      alert_loading_close();
      alert_prompt_open("提示", "当前网络正忙，请稍后重试", 1);
    }
  });
}
function getOrderEwm() {
  console.log('getOrderEwm','接口请求')

  let ewm = JSON.parse(window.sessionStorage.getItem("ewmInfo")) //二维码信息
  $.ajax({
    type: "post",
    url: config.projectUrl + '/FPGLXT/wb/queryEwmjfxz',
    contentType: "application/json;charset=utf-8",
    async: false,
    data:JSON.stringify({
      fphm: ewm.fphm,
      kpf_nsrsbh:ewm.kpf_nsrsbh,
      kprq:ewm.kprq?.replace(/[- :]/g, ''),// "2024-10-24 17:04:03" => "20241024170403"
      nsrsbh:ewm.nsrsbh,
      wjlx:'1'
    }),
    success: function (data) {
     if(data.code === '0000'){
       window.sessionStorage.setItem("ewm-URL", JSON.stringify(data.data));
     }else {
       window.sessionStorage.setItem("ewm-URL",'');
     }
    },
    error: function (data) {
      console.log(data,'error')
    }
  });
}
